// C Source File
// Created 17/10/01; 19:44:19
//Auteur DOUALOT Nicolas
////////////////////////////////////////////////////////////////////////////////
//                                                                            //
//                           		 APD_USER                       		         //
//                                                                            //
//    Ceci est un petit projet en C. Ce programme n'a aucune prtention	si ce	//
// n'est d'aider des dbutant en C tout comme moi.										//
// 	Si vous avez des questions : slubman@multimania.com                     //
//                                                                            //
//                                                                            //
////////////////////////////////////////////////////////////////////////////////



#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimisation

#define SAVE_SCREEN           // Save/Restore LCD Contents

#include <tigcclib.h>         // Include All Header Files

short _ti89;                  // Produit .89Z File
short _ti92plus;              // Produit .9XZ File


//Trac du cadre.
void trace(short lcd_height, short lcd_width)
{
	char copyright[37],info[37];
	SCR_RECT ecran,cache;
	WIN_RECT cadre;

	//Initialisation des structures  SCR_RECT
	ecran.xy.x0=0;
	ecran.xy.y0=0;
	ecran.xy.x1=2*lcd_width;
	ecran.xy.y1=2*lcd_height;

	cache.xy.x0=lcd_width-67;
	cache.xy.y0=lcd_height-29;
	cache.xy.x1=lcd_width+67;
	cache.xy.y1=lcd_height+26;
	//Fin de l'initalisation des strucures SCR_RECT

	//Initialisation de la structure WIN_RECT
	cadre.x0=lcd_width-68;
	cadre.y0=lcd_height-30;
	cadre.x1=lcd_width+68;
	cadre.y1=lcd_height+26;
	//Fin de l'initialisation de  la structure WIN_RECT

	sprintf(copyright," Par DOUALOT Nicolas  DNDD.INC %c2001",169);	// caractre n169=
	sprintf(info,"%c,%c=change [ESC]=CANCEL [ENTER]=OK",23,24);
	FontSetSys(F_6x8);						//Slection des caractres de taille moyenne.
	
	// Trac du cadre.
	ScrRectFill(&cache,&ecran,A_NORMAL);
	cache.xy.x0=lcd_width-66;
	cache.xy.y0=lcd_height-18;
	cache.xy.x1=lcd_width+66;
	cache.xy.y1=lcd_height+18;
	ScrRectFill(&cache,&ecran,A_REVERSE);
	DrawClipRect(&cadre,&ecran,A_REVERSE);
	DrawStrXY(lcd_width-24, lcd_height-27, "APD_USER", A_XOR);
	DrawStrXY(lcd_width-45,lcd_height-16,"Valeur de l'APD",A_REPLACE);
	FontSetSys(F_4x6);							//Slection des caractres de petite taille.
	DrawStrXY(lcd_width-66, lcd_height+20, copyright, A_XOR);
	DrawStrXY(lcd_width-65,lcd_height+12,info,A_REPLACE);
	FontSetSys(F_6x8);							//Slection des caractres de taille moyenne.
	// Fin du trac du cadre.
};
//Fin du trac.

// Main Function
void _main(void)
{
	//Dclaration des variables locales.
	char b[13]={"            "};
	short key,lcd_height,lcd_width;
	unsigned short apd;
	//Fin de la dclaration des variables locales.
	
	//Initialisation des variables locales.
	apd=1+OSTimerCurVal(APD_TIMER)/20;		//Rcupration de la valeur de l'apd.
	key=0;											//Correspond  la valeur de la touche appuye.
	lcd_height=LCD_HEIGHT/2;					//Centre de l'cran en hauteur.
	lcd_width=LCD_WIDTH/2;						//Centre de l'cran en largeur.
	//Fin de l'initialisation des variables locales.

	trace(lcd_height,lcd_width);				//Activation du trac du cadre.

	//Boucle principale du programme.
	do
	{
		sprintf(b," %d secondes ",apd);		//Formatage de la chane de caractres.
		DrawStrXY(lcd_width-3*strlen(b),lcd_height-3,b,A_REPLACE);
		key=ngetchx();								//Mmorisation de la touche appuye/
		if (key==KEY_UP && apd<=998) apd++;	//Si on appuis sur [HAUT].
		if (key==KEY_DOWN && apd>=11) apd--;//Si on appui sur [BAS].
	}
	while (key!=264 && (key!=13));			//Si on appui sur [ESC] ou [ENTER].
	//Fin de la boucle principale.
	
	//Enregistrement de la nouvelle valeur de l'APD si on a appuy sur [ENTER].
	if (key==13)
	{
		OSFreeTimer(APD_TIMER);					//Libration du timer corespondant l'APD.
		OSRegisterTimer(APD_TIMER, apd*20);	//Enregistrement de la nouvelle valeur.
	};
	//Fin de l'enregistrement de la nouvelle valeur de l'APD si on a appuy sur [ENTER].
}
//Fin du programme.
//	Ce programme n'a aucune vraie valeur puisque n'importe quel Shell intgre une fonction
//de rglage de l'APD, mais je l'ais cris pour ceux qui comme moi dbutent en C.
//	De plus il peut permettre de rgler l'apd sans installer de Shell sur sa calculatrice.
